import { terser } from 'rollup-plugin-terser';

const distfile = (insertion) => `dist/preserves-schema${insertion}.js`;

function umd(insertion, extra) {
  return {
    file: distfile(insertion),
    format: 'umd',
    name: 'PreservesSchema',
    globals: {
      '@preserves/core': 'Preserves',
    },
    ... (extra || {})
  };
}

function es6(insertion, extra) {
  return {
    file: distfile('.es6' + insertion),
    format: 'es',
    globals: {
      '@preserves/core': 'Preserves',
    },
    ... (extra || {}),
  };
}

export default [{
  input: 'lib/index.js',
  output: [
    umd(''),
    umd('.min', { plugins: [terser()] }),
    es6(''),
    es6('.min', { plugins: [terser()] }),
  ],
  external: ['@preserves/core'],
}, {
  input: 'lib/bin/preserves-schema-ts.js',
  output: [{
    file: 'dist/bin/preserves-schema-ts.js',
    format: 'commonjs',
  }],
  external: ['fs', 'path', 'glob', 'yargs/yargs', '@preserves/core'],
}]
