import { Record, Dictionary, Value } from '@preserves/core';
import * as M from './gen/schema';

export const BASE: M.Schema = Record(M.$schema, [new Dictionary<Value, never>([
    [M.$version, 1],
    [M.$definitions, new Dictionary<M.Pattern, never>([
        [Symbol.for('any'), Record(M.$and, [[]])],
        [Symbol.for('bool'), Record(M.$atom, [M.$Boolean])],
        [Symbol.for('float'), Record(M.$atom, [M.$Float])],
        [Symbol.for('double'), Record(M.$atom, [M.$Double])],
        [Symbol.for('int'), Record(M.$atom, [M.$SignedInteger])],
        [Symbol.for('string'), Record(M.$atom, [M.$String])],
        [Symbol.for('bytes'), Record(M.$atom, [M.$ByteString])],
        [Symbol.for('symbol'), Record(M.$atom, [M.$Symbol])],
        [Symbol.for('ref'), Record(M.$pointer, [])],
    ])],
])]);
